/* XHtmlDocument.c generated by valac 0.50.1, the Vala compiler
 * generated from XHtmlDocument.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: t; c-basic-offset: 2; tab-width: 2 -*- */
/* xNode.vala
 *
 * Copyright (C) 2015,2016  Yannick Inizan <inizan.yannick@gmail.com>
 * Copyright (C) 2015,2016  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Yannick Inizan <inizan.yannick@gmail.com>
 *      Daniel Espinosa <esodan@gmail.com>
 */
/**
 * Search all {@link GXml.Element} with a property called "class" and with a
 * value as a class apply to a node.
 */

#include "gxml/gxml.h"
#include <libxml/HTMLparser.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <libxml/HTMLtree.h>
#include <libxml/tree.h>
#include <libxml/parser.h>

enum  {
	GXML_XHTML_DOCUMENT_0_PROPERTY,
	GXML_XHTML_DOCUMENT_NUM_PROPERTIES
};
static GParamSpec* gxml_xhtml_document_properties[GXML_XHTML_DOCUMENT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _htmlFreeParserCtxt0(var) ((var == NULL) ? NULL : (var = (htmlFreeParserCtxt (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer gxml_xhtml_document_parent_class = NULL;
static GXmlDomHtmlDocumentIface * gxml_xhtml_document_gxml_dom_html_document_parent_iface = NULL;

static void gxml_xhtml_document_real_read_from_string (GXmlDomHtmlDocument* base,
                                                const gchar* str,
                                                GError** error);
static void gxml_xhtml_document_real_read_from_string_tolerant (GXmlDomHtmlDocument* base,
                                                         const gchar* str,
                                                         GError** error);
static gchar* gxml_xhtml_document_real_to_html (GXmlDomHtmlDocument* base,
                                         GError** error);
static GType gxml_xhtml_document_get_type_once (void);
static void _vala_gxml_xhtml_document_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);

gint
gxml_xhtml_document_get_default_options (void)
{
	gint result;
	result = (gint) (((HTML_PARSE_NONET | HTML_PARSE_NOWARNING) | HTML_PARSE_NOERROR) | HTML_PARSE_NOBLANKS);
	return result;
}

GXmlXHtmlDocument*
gxml_xhtml_document_construct_from_path (GType object_type,
                                         const gchar* path,
                                         gint options,
                                         GError** error)
{
	GXmlXHtmlDocument * self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = g_file_new_for_path (path);
	_tmp1_ = _tmp0_;
	self = (GXmlXHtmlDocument*) gxml_xhtml_document_construct_from_file (object_type, _tmp1_, options, NULL, &_inner_error0_);
	_g_object_unref0 (_tmp1_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (self);
		return NULL;
	}
	return self;
}

GXmlXHtmlDocument*
gxml_xhtml_document_new_from_path (const gchar* path,
                                   gint options,
                                   GError** error)
{
	return gxml_xhtml_document_construct_from_path (GXML_TYPE_XHTML_DOCUMENT, path, options, error);
}

GXmlXHtmlDocument*
gxml_xhtml_document_construct_from_uri (GType object_type,
                                        const gchar* uri,
                                        gint options,
                                        GError** error)
{
	GXmlXHtmlDocument * self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp0_ = g_file_new_for_uri (uri);
	_tmp1_ = _tmp0_;
	self = (GXmlXHtmlDocument*) gxml_xhtml_document_construct_from_file (object_type, _tmp1_, options, NULL, &_inner_error0_);
	_g_object_unref0 (_tmp1_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (self);
		return NULL;
	}
	return self;
}

GXmlXHtmlDocument*
gxml_xhtml_document_new_from_uri (const gchar* uri,
                                  gint options,
                                  GError** error)
{
	return gxml_xhtml_document_construct_from_uri (GXML_TYPE_XHTML_DOCUMENT, uri, options, error);
}

/**
 * This method parse strings in a {@link GLib.File} using {@link Html.Doc.read_memory} method.
 * Refer to libxml2 documentation about limitations on parsing.
 *
 * In order to use a different parser, may you want to load in memory your file,
 * then create a new {@link XHtmlDocument} using a constructor better fitting
 * your document content or source.
 */
GXmlXHtmlDocument*
gxml_xhtml_document_construct_from_file (GType object_type,
                                         GFile* file,
                                         gint options,
                                         GCancellable* cancel,
                                         GError** error)
{
	GXmlXHtmlDocument * self = NULL;
	GMemoryOutputStream* ostream = NULL;
	GMemoryOutputStream* _tmp0_;
	GFileInputStream* _tmp1_ = NULL;
	GFileInputStream* _tmp2_;
	GMemoryOutputStream* _tmp3_;
	GMemoryOutputStream* _tmp4_;
	void* _tmp5_;
	void* _tmp6_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	_tmp0_ = (GMemoryOutputStream*) g_memory_output_stream_new_resizable ();
	ostream = _tmp0_;
	_tmp2_ = g_file_read (file, NULL, &_inner_error0_);
	_tmp1_ = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (ostream);
		_g_object_unref0 (self);
		return NULL;
	}
	_tmp3_ = ostream;
	g_output_stream_splice ((GOutputStream*) _tmp3_, (GInputStream*) _tmp1_, G_OUTPUT_STREAM_SPLICE_CLOSE_SOURCE, cancel, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (_tmp1_);
		_g_object_unref0 (ostream);
		_g_object_unref0 (self);
		return NULL;
	}
	_tmp4_ = ostream;
	_tmp5_ = g_memory_output_stream_get_data (_tmp4_);
	_tmp6_ = _tmp5_;
	self = (GXmlXHtmlDocument*) gxml_xhtml_document_construct_from_string (object_type, (const gchar*) _tmp6_, options);
	_g_object_unref0 (_tmp1_);
	_g_object_unref0 (ostream);
	return self;
}

GXmlXHtmlDocument*
gxml_xhtml_document_new_from_file (GFile* file,
                                   gint options,
                                   GCancellable* cancel,
                                   GError** error)
{
	return gxml_xhtml_document_construct_from_file (GXML_TYPE_XHTML_DOCUMENT, file, options, cancel, error);
}

/**
 * This method parse strings using {@link Html.Doc.read_memory} method.
 * Refer to libxml2 documentation about limitations on parsing.
 */
GXmlXHtmlDocument*
gxml_xhtml_document_construct_from_string (GType object_type,
                                           const gchar* html,
                                           gint options)
{
	GXmlXHtmlDocument * self = NULL;
	gint _tmp0_;
	gint _tmp1_;
	xmlDoc* _tmp2_;
	g_return_val_if_fail (html != NULL, NULL);
	_tmp0_ = strlen (html);
	_tmp1_ = _tmp0_;
	_tmp2_ = htmlReadMemory ((gchar*) html, _tmp1_, "", NULL, options);
	self = (GXmlXHtmlDocument*) gxml_xdocument_construct_from_doc (object_type, _tmp2_);
	return self;
}

GXmlXHtmlDocument*
gxml_xhtml_document_new_from_string (const gchar* html,
                                     gint options)
{
	return gxml_xhtml_document_construct_from_string (GXML_TYPE_XHTML_DOCUMENT, html, options);
}

/**
 * This method parse strings using {@link Html.ParserCtxt} class.
 * Refer to libxml2 documentation about limitations on parsing.
 */
GXmlXHtmlDocument*
gxml_xhtml_document_construct_from_string_context (GType object_type,
                                                   const gchar* html,
                                                   gint options)
{
	GXmlXHtmlDocument * self = NULL;
	htmlParserCtxt* ctx = NULL;
	htmlParserCtxt* _tmp0_;
	xmlDoc* doc = NULL;
	gint _tmp1_;
	gint _tmp2_;
	xmlDoc* _tmp3_;
	g_return_val_if_fail (html != NULL, NULL);
	_tmp0_ = htmlNewParserCtxt ();
	ctx = _tmp0_;
	_tmp1_ = strlen (html);
	_tmp2_ = _tmp1_;
	_tmp3_ = htmlCtxtReadMemory (ctx, (gchar*) html, _tmp2_, "", NULL, options);
	doc = _tmp3_;
	self = (GXmlXHtmlDocument*) gxml_xdocument_construct_from_doc (object_type, doc);
	_htmlFreeParserCtxt0 (ctx);
	return self;
}

GXmlXHtmlDocument*
gxml_xhtml_document_new_from_string_context (const gchar* html,
                                             gint options)
{
	return gxml_xhtml_document_construct_from_string_context (GXML_TYPE_XHTML_DOCUMENT, html, options);
}

/**
 * This method parse strings using {@link Html.Doc.read_doc} method.
 * Refer to libxml2 documentation about limitations on parsing.
 */
GXmlXHtmlDocument*
gxml_xhtml_document_construct_from_string_doc (GType object_type,
                                               const gchar* html,
                                               gint options)
{
	GXmlXHtmlDocument * self = NULL;
	xmlDoc* _tmp0_;
	g_return_val_if_fail (html != NULL, NULL);
	_tmp0_ = htmlReadDoc ((xmlChar*) html, "", NULL, options);
	self = (GXmlXHtmlDocument*) gxml_xdocument_construct_from_doc (object_type, _tmp0_);
	return self;
}

GXmlXHtmlDocument*
gxml_xhtml_document_new_from_string_doc (const gchar* html,
                                         gint options)
{
	return gxml_xhtml_document_construct_from_string_doc (GXML_TYPE_XHTML_DOCUMENT, html, options);
}

static void
gxml_xhtml_document_real_read_from_string (GXmlDomHtmlDocument* base,
                                           const gchar* str,
                                           GError** error)
{
	GXmlXHtmlDocument * self;
	gint _tmp0_;
	gint _tmp1_;
	xmlDoc* _tmp2_;
	self = (GXmlXHtmlDocument*) base;
	g_return_if_fail (str != NULL);
	_tmp0_ = strlen (str);
	_tmp1_ = _tmp0_;
	_tmp2_ = htmlReadMemory ((gchar*) str, _tmp1_, "", NULL, 0);
	((GXmlXDocument*) self)->doc = _tmp2_;
}

static void
gxml_xhtml_document_real_read_from_string_tolerant (GXmlDomHtmlDocument* base,
                                                    const gchar* str,
                                                    GError** error)
{
	GXmlXHtmlDocument * self;
	htmlParserCtxt* ctx = NULL;
	htmlParserCtxt* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	xmlDoc* _tmp3_;
	self = (GXmlXHtmlDocument*) base;
	g_return_if_fail (str != NULL);
	_tmp0_ = htmlNewParserCtxt ();
	ctx = _tmp0_;
	_tmp1_ = strlen (str);
	_tmp2_ = _tmp1_;
	_tmp3_ = htmlCtxtReadMemory (ctx, (gchar*) str, _tmp2_, "", NULL, 0);
	((GXmlXDocument*) self)->doc = _tmp3_;
	_htmlFreeParserCtxt0 (ctx);
}

static gchar*
gxml_xhtml_document_real_to_html (GXmlDomHtmlDocument* base,
                                  GError** error)
{
	GXmlXHtmlDocument * self;
	gchar* buffer = NULL;
	gint len = 0;
	xmlDoc* _tmp0_;
	gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result = NULL;
	self = (GXmlXHtmlDocument*) base;
	len = 0;
	_tmp0_ = ((GXmlXDocument*) self)->doc;
	htmlDocDumpMemory ((xmlDoc*) _tmp0_, (xmlChar**) (&_tmp1_), &_tmp2_);
	_g_free0 (buffer);
	buffer = _tmp1_;
	len = _tmp2_;
	_tmp3_ = g_strdup_printf ("%i", len);
	_tmp4_ = _tmp3_;
	g_message ("XHtmlDocument.vala:96: %s", _tmp4_);
	_g_free0 (_tmp4_);
	_tmp5_ = g_strdup (buffer);
	result = _tmp5_;
	_g_free0 (buffer);
	return result;
}

GXmlXHtmlDocument*
gxml_xhtml_document_construct (GType object_type)
{
	GXmlXHtmlDocument * self = NULL;
	self = (GXmlXHtmlDocument*) gxml_xdocument_construct (object_type);
	return self;
}

GXmlXHtmlDocument*
gxml_xhtml_document_new (void)
{
	return gxml_xhtml_document_construct (GXML_TYPE_XHTML_DOCUMENT);
}

static void
gxml_xhtml_document_class_init (GXmlXHtmlDocumentClass * klass,
                                gpointer klass_data)
{
	gxml_xhtml_document_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = _vala_gxml_xhtml_document_get_property;
}

static void
gxml_xhtml_document_gxml_dom_html_document_interface_init (GXmlDomHtmlDocumentIface * iface,
                                                           gpointer iface_data)
{
	gxml_xhtml_document_gxml_dom_html_document_parent_iface = g_type_interface_peek_parent (iface);
	iface->read_from_string = (void (*) (GXmlDomHtmlDocument*, const gchar*, GError**)) gxml_xhtml_document_real_read_from_string;
	iface->read_from_string_tolerant = (void (*) (GXmlDomHtmlDocument*, const gchar*, GError**)) gxml_xhtml_document_real_read_from_string_tolerant;
	iface->to_html = (gchar* (*) (GXmlDomHtmlDocument*, GError**)) gxml_xhtml_document_real_to_html;
}

static void
gxml_xhtml_document_instance_init (GXmlXHtmlDocument * self,
                                   gpointer klass)
{
}

/**
   * HML parsing support. Document handling
   */
static GType
gxml_xhtml_document_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GXmlXHtmlDocumentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gxml_xhtml_document_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GXmlXHtmlDocument), 0, (GInstanceInitFunc) gxml_xhtml_document_instance_init, NULL };
	static const GInterfaceInfo gxml_dom_html_document_info = { (GInterfaceInitFunc) gxml_xhtml_document_gxml_dom_html_document_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gxml_xhtml_document_type_id;
	gxml_xhtml_document_type_id = g_type_register_static (GXML_TYPE_XDOCUMENT, "GXmlXHtmlDocument", &g_define_type_info, 0);
	g_type_add_interface_static (gxml_xhtml_document_type_id, GXML_TYPE_DOM_HTML_DOCUMENT, &gxml_dom_html_document_info);
	return gxml_xhtml_document_type_id;
}

GType
gxml_xhtml_document_get_type (void)
{
	static volatile gsize gxml_xhtml_document_type_id__volatile = 0;
	if (g_once_init_enter (&gxml_xhtml_document_type_id__volatile)) {
		GType gxml_xhtml_document_type_id;
		gxml_xhtml_document_type_id = gxml_xhtml_document_get_type_once ();
		g_once_init_leave (&gxml_xhtml_document_type_id__volatile, gxml_xhtml_document_type_id);
	}
	return gxml_xhtml_document_type_id__volatile;
}

static void
_vala_gxml_xhtml_document_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	GXmlXHtmlDocument * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GXML_TYPE_XHTML_DOCUMENT, GXmlXHtmlDocument);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

